﻿using DevExpress.ExpressApp;
using DevExpress.ExpressApp.Xpo;
using NUnit.Framework;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Tests.Module.BusinessObjects;
using Tests.Module.Win.BusinessObjects;

namespace NUnitTest
{
    [TestFixture]
    public class BagTests
    {
        private IObjectSpace objectSpace;
        [SetUp]
        public virtual void SetUp()
        {
            objectSpace = new XPObjectSpaceProvider(new MemoryDataStoreProvider()).CreateObjectSpace();
            XafTypesInfo.Instance.RegisterEntity("Bag", typeof(Bag));
            XafTypesInfo.Instance.GenerateEntities();
        }
        [Test]
        public void BagIsValid()
        {
            Bag bag = objectSpace.CreateObject<Bag>();
            var ext = bag.ModuleInfo();
            bag.No1 = 2;
            bag.No2 = 2;
            Assert.AreEqual(4, ext.Sum);
        }
    }
}
