﻿using DevExpress.ExpressApp.DC;
using System.Collections.Generic;
using DevExpress.Xpo;
using Xafari;
using Xafari.DC;
using Xafari.XF;
using Tests.Module.BusinessObjects;

namespace Tests.Module.Win.BusinessObjects
{
    [DomainComponent]
    [EntityExtension(typeof(Bag))]
    [RegisterExtension(typeof(Bag), PropertyName = nameof(XBag_Module_Extensions.ModuleInfo), BackPropertyName = nameof(XBag_Module_Extensions.Bag))]
    public interface XBag_Module : IXFEntityExtension
    {
        int Sum { get; set; }

        void Update();
    }

    public class XBag_ModuleLogics : Xafari.BC.DC.DomainLogics
    {
        [DomainLogic(typeof(XBag_Module))]
        public class Main : Main<XBag_Module>
        {
            public Main(XBag_Module instance)
                : base(instance)
            {
            }
           public void Update()
            {
                Bag emp = Instance.GetEntity<Bag>();
                Instance.Sum = emp.No1 + emp.No2;
            }
        }

        [DomainLogic(typeof(XBag_Module))]
        public class Events : Events<XBag_Module>
        {
            public Events(XBag_Module instance)
                : base(instance)
            {
            }

        }
    }

    public static class XBag_Module_Extensions
    {
        public static XBag_Module ModuleInfo(this Bag entity)
        {
            return entity.GetExtension<XBag_Module>();
        }

        public static Bag Bag(this XBag_Module extension)
        {
            return extension.GetEntity<Bag>();
        }
    }
}

